VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Export to Excel"
   ClientHeight    =   2475
   ClientLeft      =   5205
   ClientTop       =   3045
   ClientWidth     =   2175
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2475
   ScaleWidth      =   2175
   Begin VB.Frame Frame2 
      Caption         =   "Excel Functions"
      Height          =   2295
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
      Begin VB.CommandButton cmdQuit 
         Caption         =   "Quit"
         Height          =   375
         Left            =   240
         TabIndex        =   4
         Top             =   1800
         Width           =   1455
      End
      Begin VB.CommandButton cmdExport 
         Caption         =   "Export to Excel"
         Height          =   375
         Left            =   240
         TabIndex        =   3
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton cmdPrint 
         Caption         =   "Print Worksheet"
         Height          =   375
         Left            =   240
         TabIndex        =   2
         Top             =   1320
         Width           =   1455
      End
      Begin VB.CommandButton cmdView 
         Caption         =   "View Worksheet"
         Height          =   375
         Left            =   240
         TabIndex        =   1
         Top             =   840
         Width           =   1455
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim sNewXlsFile  As String
Dim sXlsTemplate As String

Private Const SW_SHOWNORMAL = 1

Private Const ERROR_FILE_NOT_FOUND = 2&
Private Const ERROR_PATH_NOT_FOUND = 3&
Private Const SE_ERR_ACCESSDENIED = 5
Private Const SE_ERR_OOM = 8
Private Const ERROR_BAD_FORMAT = 11&
Private Const SE_ERR_SHARE = 26
Private Const SE_ERR_ASSOCINCOMPLETE = 27
Private Const SE_ERR_DDETIMEOUT = 28
Private Const SE_ERR_DDEFAIL = 29
Private Const SE_ERR_DDEBUSY = 30
Private Const SE_ERR_NOASSOC = 31
Private Const SE_ERR_DLLNOTFOUND = 32

Private Declare Function ShellExecute Lib "shell32.dll" _
    Alias "ShellExecuteA" (ByVal hwnd As Long, _
    ByVal lpOperation As String, ByVal lpFile As String, _
    ByVal lpParameters As String, ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long

Private Sub cmdQuit_Click()
Unload Me
End Sub
Private Sub cmdExport_Click()
' Note:
' You must have a reference to the Excel Object Library.
'
Dim i           As Long
Dim j           As Long
Dim lRowCount   As Long
Dim lPasteCount As Long
Dim sLtr        As String
Dim sStart      As String
Dim sEnd        As String
Dim sRowData    As String
Dim sSelData    As String
Dim oExcelApp   As excel.Application
Dim oWs         As excel.Worksheet
Dim oWb         As excel.Workbook

Const cNUMCOLS = 6
Const cNUMROWS = 700
Const cFIXEDROWS = 6
Const cCLIPROWS = 500

On Error GoTo ErrorHandler
Screen.MousePointer = vbHourglass
If Dir(sNewXlsFile) <> "" Then Kill sNewXlsFile
'
' Create an invisible Excel instance.
'
' Open a previously created worksheet that has most
' of the desired formatting already. Save this template
' as a new file so as not to destroy it.
'
Set oExcelApp = CreateObject("EXCEL.APPLICATION")
oExcelApp.Visible = False
oExcelApp.Workbooks.Open FileName:=sXlsTemplate, ReadOnly:=True, ignoreReadOnlyRecommended:=True
Set oWs = oExcelApp.ActiveSheet
Set oWb = oExcelApp.ActiveWorkbook
oWs.SaveAs FileName:=sNewXlsFile, FileFormat:=xlNormal
'
' Populate the header information by writting
' directly to specific cells.
'
' Note:
' Strings are prefixed with a quote mark.
'
With oWs
    .Cells(1, 4).Value = "'Value1"
    .Cells(2, 4).Value = "'Value2"
    .Cells(3, 4).Value = "'Value3"
    .Cells(4, 4).Value = "'Value4 Value4 Value4 Value4 Value4 Value4"
    .Cells(5, 5).Value = "'Value5"
    .Cells(5, 6).Value = "'Value6"
    .Cells(5, 7).Value = "'Value7"
End With
'
' Now lets populate the "body" of the spreadsheet.
' Determine the range of cells to be populated
' and change their format to numeric.
'
sStart = "A" & CStr(cFIXEDROWS + 1)
sLtr = Mid$("ABCDEFGHIJKLMNOPQRSTUVWXYZ", cNUMCOLS + 1, 1)
sEnd = sLtr & CStr(cFIXEDROWS + cNUMROWS + 1)

oWs.Range(sStart, sEnd).Select
oWs.Range(sStart, sEnd).Activate
oWs.Range(sStart, sEnd).NumberFormat = "#,##0.00"
'
' Populate the body of the spreadsheet.
'
sSelData = ""
lRowCount = 0
lPasteCount = 0

For i = 0 To cNUMROWS
    sRowData = ""
    '
    ' Create the rows to send to Excel. Each row
    ' is a tab delimited string of values terminated
    ' by a carriage return and line feed. Data can
    ' come from a grid or other source.
    '
    For j = 0 To cNUMCOLS
        sRowData = sRowData & CStr(j) & vbTab
    Next
    sRowData = Left$(sRowData, Len(sRowData) - 1)
    '
    ' Rows are accumulated into blocks then stored in
    ' the clipboard and pasted into Excel in one shot.
    '
    ' They can be written one at a time but this is
    ' faster since the data is kept in memory and
    ' there are fewer calls to Excel.
    '
    sSelData = sSelData + sRowData + vbCrLf
    lRowCount = lRowCount + 1
    
    If lRowCount = cCLIPROWS Then
        Clipboard.Clear
        Clipboard.SetText sSelData
        sSelData = ""
        With oWs
            .Range("A" & CStr(lPasteCount * cCLIPROWS + cFIXEDROWS)).Select
            .Paste
            .Range("A1").Select
        End With
        lRowCount = 0
        lPasteCount = lPasteCount + 1
    End If
Next
'
' Paste the last block of data into the worksheet.
'
Clipboard.Clear
Clipboard.SetText sSelData
With oWs
    .Range("A" & CStr(lPasteCount * cCLIPROWS + cFIXEDROWS)).Select
    .Paste
    .Range("A1").Select
End With
'
' Change the formatting on a few cells.
'
' Select and highlight a cell. Change the font
' style and color on certain parts of its contents.
'
oWs.Range("D4").Select
oWs.Range("D4").Activate
With oExcelApp.ActiveCell.Characters(Start:=1, Length:=10).Font
    .FontStyle = "Regular"
    .Size = 11
    .ColorIndex = 5
End With
With oExcelApp.ActiveCell.Characters(Start:=20, Length:=30).Font
    .FontStyle = "Italic"
    .Size = 11
    .ColorIndex = xlAutomatic
End With
'
' Just for fun, change the color of
' the first column to Red.
'
sStart = "A" & CStr(cFIXEDROWS + 1)
sEnd = "A" & CStr(cFIXEDROWS + cNUMROWS + 1)
oWs.Range(sStart, sEnd).Select
oWs.Range(sStart, sEnd).Activate
oWs.Range(sStart, sEnd).Font.ColorIndex = 3
'
' Change the border and color of the last row.
'
j = (lPasteCount * cCLIPROWS) + cFIXEDROWS + lRowCount
For i = 1 To cNUMCOLS + 1
    With oWs.Cells(j, i)
        .Borders(xlTop).LineStyle = xlDouble
        .Font.Bold = True
        .Font.ColorIndex = 3
    End With
Next
'
' Make the last row a total line. Build and insert
' a formula into its first cell. Then copy the
' formula to the remaining cells.  When it is copied
' Excel will update the cell references for you.
'
oWs.Cells(j, 1).Value = "=SUM(A" & CStr(cFIXEDROWS + 1) & ":A" & CStr(j - 1) & ")"
For i = 1 To cNUMCOLS
    oWs.Cells(j, 1).Copy
    oWs.Cells(j, i + 1).Select
    oWs.Paste
Next
'
' Save the changed worksheet.
'
oWb.Save
oWb.Saved = True
'
' Terminate and release the Excel objects.
'
oExcelApp.Quit
Set oWs = Nothing
Set oWb = Nothing
Set oExcelApp = Nothing
Screen.MousePointer = vbDefault
MsgBox "Data export complete", vbInformation, "Excel Export Example"
Exit Sub

ErrorHandler:
    Screen.MousePointer = vbDefault
    MsgBox Err.Description & " (" & CStr(Err.Number) & ")", vbExclamation, "Excel Export Example"
    On Error Resume Next
    oExcelApp.Quit
    Set oWs = Nothing
    Set oWb = Nothing
    Set oExcelApp = Nothing
End Sub
Private Sub cmdPrint_Click()
Dim sNewXlsFile As String
Dim oExcelApp   As excel.Application
Dim oWs         As excel.Worksheet
Dim oWb         As excel.Workbook
'
' Make sure the file exists.
'
On Error GoTo ErrorHandler
sNewXlsFile = App.Path & "\temp.xls"
If Dir(sNewXlsFile) = "" Then
    MsgBox "Export the Excel data first.", vbExclamation, "XLS file not found"
    Exit Sub
End If
'
' Create an invisible Excel instance and open the file.
'
Screen.MousePointer = vbHourglass
Set oExcelApp = CreateObject("EXCEL.APPLICATION")
oExcelApp.Visible = False
oExcelApp.Workbooks.Open FileName:=sNewXlsFile, ReadOnly:=True, ignoreReadOnlyRecommended:=True
'
' Tell Excel to print the file.
'
Set oWs = oExcelApp.ActiveSheet
oWs.PrintOut
oExcelApp.Quit
'
' Terminate and release the Excel objects.
'
Set oWs = Nothing
Set oExcelApp = Nothing
Screen.MousePointer = vbDefault
MsgBox "Data sent to printer", vbInformation, "Excel Export Example"
Exit Sub

ErrorHandler:
    Screen.MousePointer = vbDefault
    MsgBox Err.Description & " (" & CStr(Err.Number) & ")", vbExclamation, "Excel Export Example"
    On Error Resume Next
    oExcelApp.Quit
    Set oWs = Nothing
    Set oExcelApp = Nothing
End Sub

Private Sub cmdView_Click()
Dim lresult As Long
'
' ShellExecute opens or prints a specified file.
' For a complete description see my "ShellExecute" example.
'
On Error GoTo ErrorHandler
Screen.MousePointer = vbHourglass
lresult = ShellExecute(Me.hwnd, "open", sNewXlsFile & vbNullChar, "", 0, SW_SHOWNORMAL)
Call pDisplayError(lresult)
Exit Sub

ErrorHandler:
    Screen.MousePointer = vbDefault
    MsgBox Err.Description & " (" & CStr(Err.Number) & ")", vbExclamation, "Excel Export Example"
End Sub

Private Sub Form_Load()
sXlsTemplate = App.Path & "\TheScarms.xls"
sNewXlsFile = App.Path & "\temp.xls"
End Sub

Private Sub Form_Unload(Cancel As Integer)
If Dir(sNewXlsFile) <> "" Then Kill sNewXlsFile
Set Form1 = Nothing
End Sub



Public Sub pDisplayError(ByVal lresult As Long)
Dim sError As String
'
' ShellExecute returns a value greater than 32 if there were no errors.
' Check its return code and display the associated error message.
'
Select Case lresult
    Case 0
        sError = "The operating system is out of memory or resources."
    Case ERROR_FILE_NOT_FOUND
        sError = "The specified file was not found."
    Case ERROR_PATH_NOT_FOUND
        sError = "The specified path was not found."
    Case ERROR_BAD_FORMAT
        sError = "The .exe file is invalid (non-Win32 .exe or error in .exe image)."
    Case SE_ERR_ACCESSDENIED
        sError = "The operating system denied access to the specified file."
    Case SE_ERR_ASSOCINCOMPLETE
        sError = "The file name association is incomplete or invalid."
    Case SE_ERR_DDEBUSY
        sError = "The DDE transaction could not be completed because other DDE transactions were being processed."
    Case SE_ERR_DDEFAIL
        sError = "The DDE transaction failed."
    Case SE_ERR_DDETIMEOUT
        sError = "The DDE transaction could not be completed because the request timed out."
    Case SE_ERR_DLLNOTFOUND
        sError = "The specified dynamic-link library was not found."
    Case SE_ERR_NOASSOC
        sError = "There is no application associated with the given file name extension."
    Case SE_ERR_OOM
        sError = "There was not enough memory to complete the operation."
    Case SE_ERR_SHARE
        sError = "A sharing violation occurred."
    Case Else
        sError = ""
End Select

Screen.MousePointer = vbDefault
If lresult <= 32 Then
    MsgBox sError, vbCritical, "Excel/ShellExecute Example"
End If

End Sub
